import java.awt.Color;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.ArrayList;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;
import javax.swing.border.LineBorder;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.Toolkit;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;


public class frmSudoku {

	private JFrame frmSudoku;
	private JTextField tF11;
	private JTextField tF21;
	private JTextField tF31;
	private JTextField tF12;
	private JTextField tF22;
	private JTextField tF32;
	private JTextField tF13;
	private JTextField tF23;
	private JTextField tF33;
	private JTextField tF14;
	private JTextField tF24;
	private JTextField tF34;
	private JTextField tF15;
	private JTextField tF25;
	private JTextField tF35;
	private JTextField tF16;
	private JTextField tF26;
	private JTextField tF36;
	private JTextField tF17;
	private JTextField tF27;
	private JTextField tF37;
	private JTextField tF18;
	private JTextField tF28;
	private JTextField tF38;
	private JTextField tF19;
	private JTextField tF29;
	private JTextField tF39;
	private JTextField tF41;
	private JTextField tF51;
	private JTextField tF61;
	private JTextField tF42;
	private JTextField tF52;
	private JTextField tF62;
	private JTextField tF43;
	private JTextField tF53;
	private JTextField tF63;
	private JTextField tF44;
	private JTextField tF54;
	private JTextField tF64;
	private JTextField tF45;
	private JTextField tF55;
	private JTextField tF65;
	private JTextField tF46;
	private JTextField tF56;
	private JTextField tF66;
	private JTextField tF47;
	private JTextField tF57;
	private JTextField tF67;
	private JTextField tF48;
	private JTextField tF58;
	private JTextField tF68;
	private JTextField tF49;
	private JTextField tF59;
	private JTextField tF69;
	private JTextField tF71;
	private JTextField tF81;
	private JTextField tF91;
	private JTextField tF72;
	private JTextField tF82;
	private JTextField tF92;
	private JTextField tF73;
	private JTextField tF83;
	private JTextField tF93;
	private JTextField tF74;
	private JTextField tF84;
	private JTextField tF94;
	private JTextField tF75;
	private JTextField tF85;
	private JTextField tF95;
	private JTextField tF76;
	private JTextField tF86;
	private JTextField tF96;
	private JTextField tF77;
	private JTextField tF87;
	private JTextField tF97;
	private JTextField tF78;
	private JTextField tF88;
	private JTextField tF98;
	private JTextField tF79;
	private JTextField tF89;
	private JTextField tF99;
	
	private JButton btnClear;
	private JButton btnIteration;

	

	public class TBasicCell
    {
        public int x, y; 
        public int valueSet;
        public boolean[] possible = new boolean[10];
        public JTextField tb;
    };

    public class TBlock
    {
        public int x, y; 
        public TBasicCell[] Cell = new TBasicCell[9];  // Array typ
    }

    public class TCell extends TBasicCell
    {
        public TBlock block;
    };

    
    TCell[][] field = new TCell[9][9];
    TBlock[][] gBlock = new TBlock[3][3];
    TBlock  tempBlock = new TBlock();
    int SdkState = 0;
    boolean solved = false;
    private final Action action = new SwingAction();
    private JPanel pnMainBlock;
    private JPanel pnBlock1;
    private JPanel pnBlock_2;
    private JPanel pnBlock_3;
    private JPanel pnBlock_4;
    private JPanel pnBlock_5;
    private JPanel pnBlock_6;
    private JPanel pnBlock_7;
    private JPanel pnBlock_8;
    private JPanel pnBlock_9;
    
    
    private boolean CheckPossible()
    {
        int i, j, k;
        boolean result = true;
        boolean[] foundValBlock = new boolean[10];
        boolean[] foundValRow = new boolean[10];
        boolean[] foundValCol = new boolean[10];
        
        for (i = 0; i < 3; i++)
        {
            for (j = 0; j < 3; j++)
            {
                for (k = 0; k < 10; k++)
                    foundValBlock[k] = false;
                for (k = 0; k < 9; k++)
                {
                    if (gBlock[i][j].Cell[k].valueSet > 0)
                    {
                        if (foundValBlock[gBlock[i][j].Cell[k].valueSet])
                            result = false;
                        else
                            foundValBlock[gBlock[i][j].Cell[k].valueSet] = true;
                    }
                }
            }
        }

        for (i = 0; i < 9; i++)  // check for set values in active col
        {
            for (k = 0; k < 10; k++)
                foundValCol[k] = false;
            for (j = 0; j < 9; j++)
            {
                if (field[j][i].valueSet > 0)
                {
                    if (field[j][i].valueSet <= 9)
                    {
                        if (foundValCol[field[j][i].valueSet])
                        {
                            result = false;
                        }
                        else
                        {
                            foundValCol[field[j][i].valueSet] = true;
                        }
                    }
                }
            }
        }

        for (i = 0; i < 9; i++)  // check for set values in active col
        {
            for (k = 0; k < 10; k++)
                foundValRow[k] = false;
            for (j = 0; j < 9; j++)
            {
                if (field[i][j].valueSet > 0)
                {
                    if (field[i][j].valueSet <= 9)
                    {
                        if (foundValRow[field[i][j].valueSet])
                        {
                            result = false;
                        }
                        else
                        {
                            foundValRow[field[i][j].valueSet] = true;
                        }
                    }
                }
            }
        }
        return result;
    }
    
	
    private ArrayList<Integer> FindPossible(int actX, int actY)
    {
        int i, k;
        ArrayList<Integer> possibleList = new ArrayList<Integer>();
        
       
        TBlock actBlock;
        if (!(field[actX][actY].valueSet > 0))
        {
            actBlock = field[actX][actY].block;
            boolean[] impossible = new boolean[10];
            for (i = 0; i < 10; i++)  
            {
            	impossible[i] = false;
            }
            for (i = 0; i < 9; i++)  // check for set values in active block
            {
                if (actBlock.Cell[i].valueSet > 0)
                {
                    if (actBlock.Cell[i].valueSet <= 9)
                    {
                        k = actBlock.Cell[i].valueSet;
                        impossible[k] = true;
                    }
                }
            }
            for (i = 0; i < 9; i++)  // check for set values in active row
            {
                if (field[actX][i].valueSet > 0)
                {
                    if (field[actX][i].valueSet <= 9)
                        impossible[field[actX][i].valueSet] = true;
                }
            }
            for (i = 0; i < 9; i++)  // check for set values in active col
            {
                if (field[i][actY].valueSet > 0)
                {
                    if (field[i][actY].valueSet <= 9)
                        impossible[field[i][actY].valueSet] = true;
                }
            }
            // now we have all impossible values for the actual Cell  
            if (field[actX][actY].valueSet < 0)
            {
                for (i = 1; i <= 9; i++)
                {
                	  if (!impossible[i])
                          possibleList.add(i);
                }
            }
        }
        return possibleList;
    }
    
    
    private boolean FillCell(int actIndex)
    {
        int i;
        boolean result = true;
        boolean foundOne = false;
        int nextX = -1;
        int nextY = -1;
        
        if (actIndex < 81)
        {
            while ((!foundOne) && (actIndex < 80))
            {
                actIndex++;
                nextX = actIndex % 9;
                nextY = actIndex / 9;
                foundOne = (field[nextX][nextY].valueSet == -1);
            }
            foundOne = false;
            if ((nextX >= 0) && (nextY >= 0))
            {
                if (field[nextX][ nextY].valueSet == -1)
                {
                	ArrayList<Integer> list = FindPossible(nextX, nextY);
                    if (list.size() > 0)
                    {
                        for (i = 0; i < list.size(); i++)
                        {
                            field[nextX][nextY].valueSet = list.get(i);
                            if (FillCell(actIndex))
                            {
                                i = list.size();
                                foundOne = true;
                            }
                        }
                        if (!foundOne)
                        {
                            field[nextX][nextY].valueSet = -1;
                            result = false;
                        }
                    }
                    else
                    {
                        result = false;
                    }
                }
                else
                {
                    result = true;
                }
            }
        }
        else
            result = true;
        return result;
    }

    
    private void SolveSudoku()
    {
    	int i, j;
    	String str;
    	
    	for (i = 0; i < 9; i++)
        {
            for (j = 0; j < 9; j++)
            {
            	str = field[i][j].tb.getText();
            	if(str.length() != 0)
            	{
            		field[i][j].valueSet =  Integer.parseInt(field[i][j].tb.getText());
            	}
            	else
            	{
            		field[i][j].valueSet = -1;
            	}
            }
        }
    	if(CheckPossible())
    	{
    		solved = FillCell(-1);   
    		if (solved)
    		{
    			for (i = 0; i < 9; i++)
    			{
    				for (j = 0; j < 9; j++)
    				{
    					field[i][j].tb.setText(Integer.toString(field[i][j].valueSet));
    				}
    			}
    		}
    		else
    		{
    			JOptionPane.showMessageDialog(frmSudoku, "No solution found :-(");
    		}
    	}
    	else
        {
        	JOptionPane.showMessageDialog(frmSudoku, "Twice the same number found :-(");
        }
    }
	
    private void TextChanged()
    {
    	int i, j;
    	int newValue;
    	String str;
         
        for (i = 0; i < 9; i++)
        {
        	for (j = 0; j < 9; j++)
            {
        		str = field[i][j].tb.getText();
        		if(str.length() != 0)
        		{
        			try
        			{
        				newValue = Integer.parseInt(str);
        			}
        			catch (NumberFormatException e)
        			{
        				newValue = 0;
        			}
        			if((newValue > 0) && (newValue < 10))
        			{
        				field[i][j].tb.setForeground(Color.blue);
        			}
        			else
        			{
        				field[i][j].tb.setForeground(Color.black);
        				field[i][j].tb.setText("");
        			}
        		}
        		else
        		{
        			field[i][j].tb.setForeground(Color.black);
        		}	
            }
        }
    }
    
    private void windowResized()
    {
    	int height = frmSudoku.getHeight();
    	int width = frmSudoku.getWidth();
    	btnClear.setBounds(10, height - 100, 114, 54);
    	btnIteration.setBounds(width - 140, height - 100, 114, 54);
    	pnMainBlock.setBounds(2, 0, width - 20, height - 110);
    }
    
    private void DoClear()
    {
    	int i, j;
         
        for (i = 0; i < 9; i++)
        {
        	for (j = 0; j < 9; j++)
            {
        		field[i][j].tb.setText("");
        		field[i][j].valueSet = -1;
        		field[i][j].tb.setForeground(Color.black);
            }
        }
     }

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					frmSudoku window = new frmSudoku();
					window.frmSudoku.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public frmSudoku() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		int i,j;
		int x, y, dx, dy;
		frmSudoku = new JFrame();
		frmSudoku.addComponentListener(new ComponentAdapter() {
			@Override
			public void componentResized(ComponentEvent e) {
				windowResized();
			}
		});
		frmSudoku.setIconImage(Toolkit.getDefaultToolkit().getImage(frmSudoku.class.getResource("/Ressource/Icon.png")));
		frmSudoku.setTitle("Sudoku");
		frmSudoku.getContentPane().setFont(new Font("Arial", Font.PLAIN, 14));
		frmSudoku.setBounds(100, 100, 593, 483);
		frmSudoku.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmSudoku.getContentPane().setLayout(null);
		
		
		pnMainBlock = new JPanel();
		pnMainBlock.setLayout(new GridLayout(3, 3, 10, 10));
		pnMainBlock.setBounds(2, 0, 571, 376);
		frmSudoku.getContentPane().add(pnMainBlock);
		//--------------------------------------------- Block 1 ------------------------------------------------
		
		pnBlock1 = new JPanel();
		pnBlock1.setBorder(new LineBorder(Color.GRAY));
		pnBlock1.setBounds(2, 0, 191, 127);
		pnBlock1.setLayout(new GridLayout(3, 3, 10, 10));
		pnMainBlock.add(pnBlock1);
		 
		tF11 = new JTextField();
		tF11.setForeground(Color.BLACK);
		tF11.setToolTipText("");
		tF11.setHorizontalAlignment(SwingConstants.CENTER);
		tF11.setFont(new Font("Arial", Font.PLAIN, 14));
		tF11.setText("3");
		pnBlock1.add(tF11);
		
		tF12 = new JTextField();
		tF12.setHorizontalAlignment(SwingConstants.CENTER);
		tF12.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock1.add(tF12);
		
		tF13 = new JTextField();
		tF13.setText("7");
		tF13.setHorizontalAlignment(SwingConstants.CENTER);
		tF13.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock1.add(tF13);
		
		tF21 = new JTextField();
		tF21.setFont(new Font("Arial", Font.PLAIN, 14));
		tF21.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock1.add(tF21);
		
		tF22 = new JTextField();
		tF22.setHorizontalAlignment(SwingConstants.CENTER);
		tF22.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock1.add(tF22);
		
		tF23 = new JTextField();
		tF23.setHorizontalAlignment(SwingConstants.CENTER);
		tF23.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock1.add(tF23);
		
		tF31 = new JTextField();
		tF31.setFont(new Font("Arial", Font.PLAIN, 14));
		tF31.setHorizontalAlignment(SwingConstants.CENTER);
		tF31.setText("9");
		pnBlock1.add(tF31);
		
		
		tF32 = new JTextField();
		tF32.setHorizontalAlignment(SwingConstants.CENTER);
		tF32.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock1.add(tF32);
						
		tF33 = new JTextField();
		tF33.setHorizontalAlignment(SwingConstants.CENTER);
		tF33.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock1.add(tF33);
		
		//--------------------------------------------- Block 2 ------------------------------------------------
		
		pnBlock_2 = new JPanel();
		pnBlock_2.setBorder(new LineBorder(Color.GRAY));
		pnBlock_2.setBounds(192, 0, 191, 127);
		pnBlock_2.setLayout(new GridLayout(3, 3, 10, 10));
		pnMainBlock.add(pnBlock_2);
		
		tF14 = new JTextField();
		tF14.setHorizontalAlignment(SwingConstants.CENTER);
		tF14.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_2.add(tF14);
		
		tF15 = new JTextField();
		tF15.setText("1");
		tF15.setHorizontalAlignment(SwingConstants.CENTER);
		tF15.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_2.add(tF15);
		
		tF16 = new JTextField();
		tF16.setHorizontalAlignment(SwingConstants.CENTER);
		tF16.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_2.add(tF16);
		
		tF24 = new JTextField();
		tF24.setHorizontalAlignment(SwingConstants.CENTER);
		tF24.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_2.add(tF24);
		
		tF25 = new JTextField();
		tF25.setHorizontalAlignment(SwingConstants.CENTER);
		tF25.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_2.add(tF25);
		
		tF26 = new JTextField();
		tF26.setHorizontalAlignment(SwingConstants.CENTER);
		tF26.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_2.add(tF26);
		
		tF34 = new JTextField();
		tF34.setText("5");
		tF34.setHorizontalAlignment(SwingConstants.CENTER);
		tF34.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_2.add(tF34);
	
		
		tF35 = new JTextField();
		tF35.setHorizontalAlignment(SwingConstants.CENTER);
		tF35.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_2.add(tF35);
				
		tF36 = new JTextField();
		tF36.setText("3");
		tF36.setHorizontalAlignment(SwingConstants.CENTER);
		tF36.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_2.add(tF36);
		
		//--------------------------------------------- Block 3 ------------------------------------------------
		 
		pnBlock_3 = new JPanel();
		pnBlock_3.setBorder(new LineBorder(Color.GRAY));
		pnBlock_3.setBounds(382, 0, 191, 127);
		pnBlock_3.setLayout(new GridLayout(3, 3, 10, 10));
		pnMainBlock.add(pnBlock_3);
		

		tF17 = new JTextField();
		tF17.setText("4");
		tF17.setHorizontalAlignment(SwingConstants.CENTER);
		tF17.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_3.add(tF17);
		
		tF18 = new JTextField();
		tF18.setHorizontalAlignment(SwingConstants.CENTER);
		tF18.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_3.add(tF18);
		
		tF19 = new JTextField();
		tF19.setHorizontalAlignment(SwingConstants.CENTER);
		tF19.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_3.add(tF19);
		
		tF27 = new JTextField();
		tF27.setText("8");
		tF27.setHorizontalAlignment(SwingConstants.CENTER);
		tF27.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_3.add(tF27);
		
		tF28 = new JTextField();
		tF28.setHorizontalAlignment(SwingConstants.CENTER);
		tF28.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_3.add(tF28);
		
		tF29 = new JTextField();
		tF29.setHorizontalAlignment(SwingConstants.CENTER);
		tF29.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_3.add(tF29);
		
		tF37 = new JTextField();
		tF37.setHorizontalAlignment(SwingConstants.CENTER);
		tF37.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_3.add(tF37);	
		
		tF38 = new JTextField();
		tF38.setText("6");
		tF38.setHorizontalAlignment(SwingConstants.CENTER);
		tF38.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_3.add(tF38);
			
		tF39 = new JTextField();
		tF39.setText("1");
		tF39.setHorizontalAlignment(SwingConstants.CENTER);
		tF39.setFont(new Font("Arial", Font.PLAIN, 14));
		pnBlock_3.add(tF39);
		 	
	    // ------------------------------------------ 	Block_4  ------------------------------------------------
		
		pnBlock_4 = new JPanel();
		pnBlock_4.setBorder(new LineBorder(Color.GRAY));
		pnBlock_4.setBounds(2, 126, 191, 127);
		pnBlock_4.setLayout(new GridLayout(3, 3, 10, 10));
		pnMainBlock.add(pnBlock_4);
		
		tF41 = new JTextField();
		tF41.setToolTipText("");
		tF41.setFont(new Font("Arial", Font.PLAIN, 14));
		tF41.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_4.add(tF41);
		
		tF42 = new JTextField();
		tF42.setFont(new Font("Arial", Font.PLAIN, 14));
		tF42.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_4.add(tF42);
		
		tF43 = new JTextField();
		tF43.setText("2");
		tF43.setFont(new Font("Arial", Font.PLAIN, 14));
		tF43.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_4.add(tF43);
		
		tF51 = new JTextField();
		tF51.setText("8");
		tF51.setFont(new Font("Arial", Font.PLAIN, 14));
		tF51.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_4.add(tF51);
		
		tF52 = new JTextField();
		tF52.setFont(new Font("Arial", Font.PLAIN, 14));
		tF52.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_4.add(tF52);
		
		tF53 = new JTextField();
		tF53.setFont(new Font("Arial", Font.PLAIN, 14));
		tF53.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_4.add(tF53);
		
		tF61 = new JTextField();
		tF61.setFont(new Font("Arial", Font.PLAIN, 14));
		tF61.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_4.add(tF61);
			
		tF62 = new JTextField();
		tF62.setFont(new Font("Arial", Font.PLAIN, 14));
		tF62.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_4.add(tF62);
		
		tF63 = new JTextField();
		tF63.setForeground(Color.BLUE);
		tF63.setText("4");
		tF63.setFont(new Font("Arial", Font.PLAIN, 14));
		tF63.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_4.add(tF63);
		
		 // ------------------------------------------ 	Block_5  ------------------------------------------------
		
		pnBlock_5 = new JPanel();
		pnBlock_5.setBorder(new LineBorder(Color.GRAY));
		pnBlock_5.setBounds(192, 126, 191, 127);
		pnBlock_5.setLayout(new GridLayout(3, 3, 10, 10));
		pnMainBlock.add(pnBlock_5);
		
		tF44 = new JTextField();
		tF44.setFont(new Font("Arial", Font.PLAIN, 14));
		tF44.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_5.add(tF44);
	
		tF45 = new JTextField();
		tF45.setFont(new Font("Arial", Font.PLAIN, 14));
		tF45.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_5.add(tF45);
		
		tF46 = new JTextField();
		tF46.setFont(new Font("Arial", Font.PLAIN, 14));
		tF46.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_5.add(tF46);
		
		tF54 = new JTextField();
		tF54.setFont(new Font("Arial", Font.PLAIN, 14));
		tF54.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_5.add(tF54);
		
		tF55 = new JTextField();
		tF55.setFont(new Font("Arial", Font.PLAIN, 14));
		tF55.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_5.add(tF55);
		
		tF56 = new JTextField();
		tF56.setFont(new Font("Arial", Font.PLAIN, 14));
		tF56.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_5.add(tF56);
		
		tF64 = new JTextField();
		tF64.setFont(new Font("Arial", Font.PLAIN, 14));
		tF64.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_5.add(tF64);
		
		tF65 = new JTextField();
		tF65.setFont(new Font("Arial", Font.PLAIN, 14));
		tF65.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_5.add(tF65);
		 		
		tF66 = new JTextField();
		tF66.setFont(new Font("Arial", Font.PLAIN, 14));
		tF66.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_5.add(tF66);
		
		
		//  ---------------------------------------- Block 6 --------------------------------------------------
		
		pnBlock_6 = new JPanel();	
		pnBlock_6.setBorder(new LineBorder(Color.GRAY));
		pnBlock_6.setBounds(382, 126, 191, 127);
		pnBlock_6.setLayout(new GridLayout(3, 3, 10, 10));
		pnMainBlock.add(pnBlock_6);
		
		tF47 = new JTextField();
		tF47.setText("1");
		tF47.setFont(new Font("Arial", Font.PLAIN, 14));
		tF47.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_6.add(tF47);
		
		tF48 = new JTextField();
		tF48.setFont(new Font("Arial", Font.PLAIN, 14));
		tF48.setHorizontalAlignment(SwingConstants.CENTER);
		tF48.setColumns(10);
		tF48.setBounds(452, 138, 51, 28);
		pnBlock_6.add(tF48);
		
		tF49 = new JTextField();
		tF49.setFont(new Font("Arial", Font.PLAIN, 14));
		tF49.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_6.add(tF49);
		
		tF57 = new JTextField();
		tF57.setFont(new Font("Arial", Font.PLAIN, 14));
		tF57.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_6.add(tF57);
		
		tF58 = new JTextField();
		tF58.setFont(new Font("Arial", Font.PLAIN, 14));
		tF58.setHorizontalAlignment(SwingConstants.CENTER);
		tF58.setColumns(10);
		tF58.setBounds(452, 177, 51, 28);
		pnBlock_6.add(tF58);
		
		tF59 = new JTextField();
		tF59.setText("7");
		tF59.setFont(new Font("Arial", Font.PLAIN, 14));
		tF59.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_6.add(tF59);
		
		tF67 = new JTextField();
		tF67.setText("5");
		tF67.setFont(new Font("Arial", Font.PLAIN, 14));
		tF67.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_6.add(tF67);
				
		tF68 = new JTextField();
		tF68.setFont(new Font("Arial", Font.PLAIN, 14));
		tF68.setHorizontalAlignment(SwingConstants.CENTER);
		tF68.setColumns(10);
		tF68.setBounds(452, 216, 51, 28);
		pnBlock_6.add(tF68);
				
		tF69 = new JTextField();
		tF69.setFont(new Font("Arial", Font.PLAIN, 14));
		tF69.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_6.add(tF69);
		
		//--------------------------------------------- Block 7 ----------------------------------------------
		 
		pnBlock_7 = new JPanel();
		pnBlock_7.setBorder(new LineBorder(Color.GRAY));
		pnBlock_7.setBounds(2, 252, 191, 127);
		pnBlock_7.setLayout(new GridLayout(3, 3, 10, 10));
		pnMainBlock.add(pnBlock_7);
		
		tF71 = new JTextField();
		tF71.setText("7");
		tF71.setFont(new Font("Arial", Font.PLAIN, 14));
		tF71.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_7.add(tF71);
		 
		tF72 = new JTextField();
		tF72.setText("2");
		tF72.setFont(new Font("Arial", Font.PLAIN, 14));
		tF72.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_7.add(tF72);
		
		tF73 = new JTextField();
		tF73.setFont(new Font("Arial", Font.PLAIN, 14));
		tF73.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_7.add(tF73);
		
		tF81 = new JTextField();
		tF81.setFont(new Font("Arial", Font.PLAIN, 14));
		tF81.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_7.add(tF81);
		
		tF82 = new JTextField();
		tF82.setFont(new Font("Arial", Font.PLAIN, 14));
		tF82.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_7.add(tF82);
		
		tF83 = new JTextField();
		tF83.setText("5");
		tF83.setFont(new Font("Arial", Font.PLAIN, 14));
		tF83.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_7.add(tF83);
		
		tF91 = new JTextField();
		tF91.setFont(new Font("Arial", Font.PLAIN, 14));
		tF91.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_7.add(tF91);
				
		tF92 = new JTextField();
		tF92.setFont(new Font("Arial", Font.PLAIN, 14));
		tF92.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_7.add(tF92);	
		
		tF93 = new JTextField();
		tF93.setText("9");
		tF93.setFont(new Font("Arial", Font.PLAIN, 14));
		tF93.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_7.add(tF93);
		
		//------------------------------------------ Block 8 -------------------------------------------------
		
		pnBlock_8 = new JPanel();
		pnBlock_8.setBorder(new LineBorder(Color.GRAY));
		pnBlock_8.setBounds(192, 252, 191, 127);
		pnBlock_8.setLayout(new GridLayout(3, 3, 10, 10));
		pnMainBlock.add(pnBlock_8);
		
		tF74 = new JTextField();
		tF74.setText("8");
		tF74.setFont(new Font("Arial", Font.PLAIN, 14));
		tF74.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_8.add(tF74);
		
		tF75 = new JTextField();
		tF75.setFont(new Font("Arial", Font.PLAIN, 14));
		tF75.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_8.add(tF75);
		
		tF76 = new JTextField();
		tF76.setText("1");
		tF76.setFont(new Font("Arial", Font.PLAIN, 14));
		tF76.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_8.add(tF76);
		
		tF84 = new JTextField();
		tF84.setFont(new Font("Arial", Font.PLAIN, 14));
		tF84.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_8.add(tF84);
		
		tF85 = new JTextField();
		tF85.setFont(new Font("Arial", Font.PLAIN, 14));
		tF85.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_8.add(tF85);
		
		tF86 = new JTextField();
		tF86.setFont(new Font("Arial", Font.PLAIN, 14));
		tF86.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_8.add(tF86);
		
		tF94 = new JTextField();
		tF94.setFont(new Font("Arial", Font.PLAIN, 14));
		tF94.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_8.add(tF94);
		 		
		tF95 = new JTextField();
		tF95.setText("5");
		tF95.setFont(new Font("Arial", Font.PLAIN, 14));
		tF95.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_8.add(tF95);
				
		tF96 = new JTextField();
		tF96.setFont(new Font("Arial", Font.PLAIN, 14));
		tF96.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_8.add(tF96);
						
		//--------------------------------------------- Block 9 ---------------------------------------------------------
		
		pnBlock_9 = new JPanel();
		pnBlock_9.setBorder(new LineBorder(Color.GRAY));
		pnBlock_9.setBounds(382, 252, 191, 127);
		pnBlock_9.setLayout(new GridLayout(3, 3, 10, 10));
		pnMainBlock.add(pnBlock_9);
		
		tF77 = new JTextField();
		tF77.setFont(new Font("Arial", Font.PLAIN, 14));
		tF77.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_9.add(tF77);
		
		tF78 = new JTextField();
		tF78.setFont(new Font("Arial", Font.PLAIN, 14));
		tF78.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_9.add(tF78);
		
		tF79 = new JTextField();
		tF79.setText("9");
		tF79.setFont(new Font("Arial", Font.PLAIN, 14));
		tF79.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_9.add(tF79);
		
		tF87 = new JTextField();
		tF87.setFont(new Font("Arial", Font.PLAIN, 14));
		tF87.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_9.add(tF87);
		
		tF88 = new JTextField();
		tF88.setFont(new Font("Arial", Font.PLAIN, 14));
		tF88.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_9.add(tF88);
		
		tF89 = new JTextField();
		tF89.setFont(new Font("Arial", Font.PLAIN, 14));
		tF89.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_9.add(tF89);
		
		tF97 = new JTextField();
		tF97.setText("6");
		tF97.setFont(new Font("Arial", Font.PLAIN, 14));
		tF97.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_9.add(tF97);	
		
		tF98 = new JTextField();
		tF98.setFont(new Font("Arial", Font.PLAIN, 14));
		tF98.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_9.add(tF98);
		
		tF99 = new JTextField();
		tF99.setText("2");
		tF99.setFont(new Font("Arial", Font.PLAIN, 14));
		tF99.setHorizontalAlignment(SwingConstants.CENTER);
		pnBlock_9.add(tF99);
		
				
		btnIteration = new JButton("Iteration");
		btnIteration.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				SolveSudoku();
			}
		});
		
		btnIteration.setBounds(452, 384, 114, 54);
		frmSudoku.getContentPane().add(btnIteration);
		
		
		// organize blocks and cells
        for (y = 0; y < 3; y++) //init the 9 blocks containing 9 cells
        {
            for (x = 0; x < 3; x++)
            {
                gBlock[x][y] = new TBlock();
                gBlock[x][y].x = x;
                gBlock[x][y].y = y;
            }
        }
        for (y = 0; y < 9; y++)
        {
            for (x = 0; x < 9; x++)
            {
                field[x][y] = new TCell();
                field[x][y].valueSet = -1;
                field[x][y].x = x;
                field[x][y].y = y;
                for (i = 1; i <= 9; i++)
                {
                    field[x][y].possible[i] = false;
                }
            }
        }
        for (y = 0; y < 3; y++)
        {
            for (x = 0; x < 3; x++)
            {
                for (dy = 0; dy < 3; dy++)
                {
                    for (dx = 0; dx < 3; dx++)
                    {
                        gBlock[x][y].Cell[dx + 3 * dy] = field[x*3+dx][y*3+dy];
                    }
                }
            }
        }
        for (y = 0; y < 3; y++)
        {
            for (x = 0; x < 3; x++)
            {
                field[x][y].block = gBlock[0][0];
                field[x + 3][y].block = gBlock[1][0];
                field[x + 6][y].block = gBlock[2][0];
                field[x][y + 3].block = gBlock[0][1];
                field[x + 3][y + 3].block = gBlock[1][1];
                field[x + 6][y + 3].block = gBlock[2][1];
                field[x][ y + 6].block = gBlock[0][2];
                field[x + 3][y + 6].block = gBlock[1][2];
                field[x + 6][y + 6].block = gBlock[2][2];
            }
        }
	
        field[0][0].tb = tF11; field[1][0].tb = tF12; field[2][0].tb = tF13;
        field[3][0].tb = tF14; field[4][0].tb = tF15; field[5][0].tb = tF16;
        field[6][0].tb = tF17; field[7][0].tb = tF18; field[8][0].tb = tF19;

        field[0][1].tb = tF21; field[1][1].tb = tF22; field[2][1].tb = tF23;
        field[3][1].tb = tF24; field[4][1].tb = tF25; field[5][1].tb = tF26;
        field[6][1].tb = tF27; field[7][1].tb = tF28; field[8][1].tb = tF29;

        field[0][2].tb = tF31; field[1][2].tb = tF32; field[2][2].tb = tF33;
        field[3][2].tb = tF34; field[4][2].tb = tF35; field[5][2].tb = tF36;
        field[6][2].tb = tF37; field[7][2].tb = tF38; field[8][2].tb = tF39;

        field[0][3].tb = tF41; field[1][3].tb = tF42; field[2][3].tb = tF43;
        field[3][3].tb = tF44; field[4][3].tb = tF45; field[5][3].tb = tF46;
        field[6][3].tb = tF47; field[7][3].tb = tF48; field[8][3].tb = tF49;

        field[0][4].tb = tF51; field[1][4].tb = tF52; field[2][4].tb = tF53;
        field[3][4].tb = tF54; field[4][4].tb = tF55; field[5][4].tb = tF56;
        field[6][4].tb = tF57; field[7][4].tb = tF58; field[8][4].tb = tF59;

        field[0][5].tb = tF61; field[1][5].tb = tF62; field[2][5].tb = tF63;
        field[3][5].tb = tF64; field[4][5].tb = tF65; field[5][5].tb = tF66;
        field[6][5].tb = tF67; field[7][5].tb = tF68; field[8][5].tb = tF69;

        field[0][6].tb = tF71; field[1][6].tb = tF72; field[2][6].tb = tF73;
        field[3][6].tb = tF74; field[4][6].tb = tF75; field[5][6].tb = tF76;
        field[6][6].tb = tF77; field[7][6].tb = tF78; field[8][6].tb = tF79;

        field[0][7].tb = tF81; field[1][7].tb = tF82; field[2][7].tb = tF83;
        field[3][7].tb = tF84; field[4][7].tb = tF85; field[5][7].tb = tF86;
        field[6][7].tb = tF87; field[7][7].tb = tF88; field[8][7].tb = tF89;

        field[0][8].tb = tF91; field[1][8].tb = tF92; field[2][8].tb = tF93;
        field[3][8].tb = tF94; field[4][8].tb = tF95; field[5][8].tb = tF96;
        field[6][8].tb = tF97; field[7][8].tb = tF98; field[8][8].tb = tF99;
  
        btnClear = new JButton("Clear");
        btnClear.addMouseListener(new MouseAdapter() {
        	@Override
        	public void mouseClicked(MouseEvent e) {
        		DoClear();
        	}
        });
        btnClear.setBounds(10, 384, 114, 54);
        frmSudoku.getContentPane().add(btnClear);
        
        //initialize fields
        for (i = 0; i < 9; i++)
        {
            for (j = 0; j < 9; j++)
            {
            	field[i][j].tb.addKeyListener(new KeyAdapter() {
        			@Override
        			public void keyReleased(KeyEvent e) {
        				TextChanged();
        			}
        		});
                if (!field[i][j].tb.getText().equals(""))
                {
                    field[i][j].valueSet =Integer.parseInt(field[i][j].tb.getText());
                }
                else
                {
                    field[i][j].valueSet = -1;
                }
            }
        }
        TextChanged();
	}
	
	
	private class SwingAction extends AbstractAction {
		private static final long serialVersionUID = 1L;
		public SwingAction() {
			putValue(NAME, "SwingAction");
			putValue(SHORT_DESCRIPTION, "Some short description");
		}
		public void actionPerformed(ActionEvent e) {
		}
	}
}

